import React from 'react';
import { FormControlProps } from 'amis-core';
import { SpinnerExtraProps } from 'amis-ui';
import { FormBaseControlSchema } from '../../Schema';
import * as IconSelectStore from './IconSelectStore';
export interface IconSelectControlSchema extends FormBaseControlSchema {
    type: 'icon-select';
    placeholder?: string;
    disabled?: boolean;
    noDataTip?: string;
    clearable?: boolean;
}
export interface IconSelectProps extends FormControlProps, SpinnerExtraProps {
    placeholder?: string;
    disabled?: boolean;
    noDataTip?: string;
}
export interface IconChecked {
    id: string;
    name?: string;
}
export interface IconSelectState {
    showModal: boolean;
    tmpCheckIconId: IconChecked | null;
    searchValue: string;
    activeTypeIndex: number;
    isRefreshLoading?: boolean;
}
/**
 * 新图标选择器
 */
export default class IconSelectControl extends React.PureComponent<IconSelectProps, IconSelectState> {
    input?: HTMLInputElement;
    static defaultProps: Pick<IconSelectProps, 'noDataTip' | 'clearable'>;
    state: IconSelectState;
    constructor(props: IconSelectProps);
    handleClick(): void;
    handleClear(e: React.MouseEvent): void;
    renderInputArea(): JSX.Element;
    handleIconTypeClick(item: any, index: number): void;
    renderIconTypes(): JSX.Element;
    handleConfirm(): void;
    handleClickIconInModal(icon: IconChecked): void;
    renderIconList(icons: IconSelectStore.SvgIcon[]): JSX.Element;
    handleSearchValueChange(e: string): void;
    handleRefreshIconList(): Promise<void>;
    renderModalContent(): JSX.Element;
    getIconsByType(): IconSelectStore.SvgIcon[];
    toggleModel(isShow?: boolean): void;
    render(): JSX.Element;
}
export declare class IconSelectControlRenderer extends IconSelectControl {
}
